package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function7;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import net.minecraft.world.level.BaseSpawner;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;

public final class SpawnerStats extends Record {
  private final int spawnDelay;
  
  private final int minDelay;
  
  private final int maxDelay;
  
  private final int spawnCount;
  
  private final int maxNearbyEntities;
  
  private final int spawnRange;
  
  private final int playerRange;
  
  public static final Codec<dev.shadowsoffire.apotheosis.util.SpawnerStats> CODEC;
  
  public SpawnerStats(int spawnDelay, int minDelay, int maxDelay, int spawnCount, int maxNearbyEntities, int spawnRange, int playerRange) {
    this.spawnDelay = spawnDelay;
    this.minDelay = minDelay;
    this.maxDelay = maxDelay;
    this.spawnCount = spawnCount;
    this.maxNearbyEntities = maxNearbyEntities;
    this.spawnRange = spawnRange;
    this.playerRange = playerRange;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/util/SpawnerStats;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #10	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/util/SpawnerStats;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/util/SpawnerStats;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #10	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/util/SpawnerStats;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/util/SpawnerStats;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #10	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/util/SpawnerStats;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public int spawnDelay() {
    return this.spawnDelay;
  }
  
  public int minDelay() {
    return this.minDelay;
  }
  
  public int maxDelay() {
    return this.maxDelay;
  }
  
  public int spawnCount() {
    return this.spawnCount;
  }
  
  public int maxNearbyEntities() {
    return this.maxNearbyEntities;
  }
  
  public int spawnRange() {
    return this.spawnRange;
  }
  
  public int playerRange() {
    return this.playerRange;
  }
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)PlaceboCodecs.nullableField((Codec)Codec.INT, "spawn_delay", Integer.valueOf(20)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::spawnDelay), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "min_delay", Integer.valueOf(200)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::minDelay), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "max_delay", Integer.valueOf(800)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::maxDelay), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "spawn_count", Integer.valueOf(4)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::spawnCount), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "max_nearby_entities", Integer.valueOf(6)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::maxNearbyEntities), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "spawn_range", Integer.valueOf(4)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::spawnRange), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "player_activation_range", Integer.valueOf(16)).forGetter(dev.shadowsoffire.apotheosis.util.SpawnerStats::playerRange)).apply((Applicative)inst, dev.shadowsoffire.apotheosis.util.SpawnerStats::new));
  }
  
  public SpawnerStats() {
    this(20, 200, 800, 4, 6, 4, 16);
  }
  
  public void apply(SpawnerBlockEntity entity) {
    BaseSpawner base = entity.f_59788_;
    base.f_45442_ = this.spawnDelay;
    base.f_45447_ = this.minDelay;
    base.f_45448_ = this.maxDelay;
    base.f_45449_ = this.spawnCount;
    base.f_45451_ = this.maxNearbyEntities;
    base.f_45453_ = this.spawnRange;
    base.f_45452_ = this.playerRange;
  }
}
